/*
 * Demonstrate File I/O Weirdness 
 */

#include <bsp.h>
#include <tmacros.h>
#include <ftpd.h>
#include <rtems/rtems_bsdnet.h>

#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_EXECUTIVE_RAM_SIZE	(512*1024)
#define CONFIGURE_MAXIMUM_SEMAPHORES	20
#define CONFIGURE_MAXIMUM_TASKS		20
#define CONFIGURE_MICROSECONDS_PER_TICK	10000
#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS	10
#define CONFIGURE_USE_IMFS_AS_BASE_FILESYSTEM
#define CONFIGURE_INIT_TASK_STACK_SIZE	(10*1024)
#define CONFIGURE_INIT_TASK_PRIORITY	120
#define CONFIGURE_INIT_TASK_INITIAL_MODES (RTEMS_PREEMPT | \
                                           RTEMS_NO_TIMESLICE | \
                                           RTEMS_NO_ASR | \
                                           RTEMS_INTERRUPT_LEVEL(0))
#define CONFIGURE_INIT

struct rtems_ftpd_configuration rtems_ftpd_configuration = {
  40,
  1024,
  21,
  NULL
};

rtems_task Init (rtems_task_argument argument);

#include <confdefs.h>
#include <stdio.h>
#include "networkconfig.h"

/***********************************************************************
*
*  Open/Create a File and write to it
*
***********************************************************************/
static void
test_file (char *filename, char *mode)
{
  FILE *fp;
  fp = fopen (filename, mode);
  if (!fp)
      perror ("fopen");
  fprintf (fp, "this is a test line\n");
  if (fclose (fp))
      perror ("fclose");
}

/***********************************************************************
*
*  Initialization Task 
*
***********************************************************************/
rtems_task Init (rtems_task_argument ignored)
{
  /* use FTP to retrieve test files */
  rtems_filesystem_initialize ();
  rtems_bsdnet_initialize_network ();
  rtems_initialize_ftpd ();

  /* creating/appending a file works the 
     first time */

  printf ("Writing First File\n");
  test_file ("/one.txt", "a");
  test_file ("/one.txt", "a");

  /* but not the second time - this will insert junk.
     the number of ^@'s seems to equal the number of
     actual characters in the file */

  printf ("Writing Second File\n");
  test_file ("/two.txt", "a");
  test_file ("/two.txt", "a");

  printf ("Done. Use FTP to retrieve files\n");
  rtems_task_delete (RTEMS_SELF);
}
