#ifndef _RTEMS_NETWORKCONFIG_H_
#define _RTEMS_NETWORKCONFIG_H_

#include <bsp.h>

extern int rtems_bsdnet_loopattach();

char ethernet_address[6] = { 0x00, 0x60, 0x38, 0x87, 0x07, 0xF2 };

static struct rtems_bsdnet_ifconfig loopback_config = {
	"lo0",
	rtems_bsdnet_loopattach,
	NULL,
	"127.0.0.1",
	"255.0.0.0",
};

static struct rtems_bsdnet_ifconfig netdriver_config = {
	RTEMS_BSP_NETWORK_DRIVER_NAME,
	RTEMS_BSP_NETWORK_DRIVER_ATTACH,
	&loopback_config,
	"192.168.1.2",	
	"255.255.255.0",
	ethernet_address,
};

struct rtems_bsdnet_config rtems_bsdnet_config = {
	&netdriver_config,
	NULL,
	0,			/* Default network task priority */
	0,			/* Default mbuf capacity */
	0,			/* Default mbuf cluster capacity */
	"rtems",		/* Host name */
	"private.net",		/* Domain name */
	"192.168.1.1",	/* Gateway */
	"192.168.1.1",	/* Log host */
	{"192.168.1.1"},	/* Name server(s) */
	{"192.168.1.1"},	/* NTP server(s) */
};

#endif /* _RTEMS_NETWORKCONFIG_H_ */
